/* we have to include loader2.h before windows.h */
#include "loader2.h"
#include <windows.h>
#include <stdio.h>

int main(void)
{
	int ret;
	PROCESS_INFORMATION pi;
	int i, n = 0;
	int param_size;
	loader2_param_t *param;

	param_size = loader2_param_t_size(10);
	param = malloc(param_size);
	param->fdn = 0;

	param->fds[param->fdn].fd = 0;
	param->fds[param->fdn].handle = GetStdHandle(STD_INPUT_HANDLE);
	param->fds[param->fdn].mode = LOADER2_FD_MODE_READ|LOADER2_FD_MODE_TEXT;
	param->fdn++;

	param->fds[param->fdn].fd = 1;
	param->fds[param->fdn].handle = CreateFile("outide", GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);//GetStdHandle(STD_OUTPUT_HANDLE);
	param->fds[param->fdn].mode = LOADER2_FD_MODE_WRITE|LOADER2_FD_MODE_TEXT;
	param->fdn++;

	param->fds[param->fdn].fd = 2;
	param->fds[param->fdn].handle = GetStdHandle(STD_ERROR_HANDLE);
	param->fds[param->fdn].mode = LOADER2_FD_MODE_WRITE|LOADER2_FD_MODE_TEXT;
	param->fdn++;

	param->fds[param->fdn].fd = 3;
	param->fds[param->fdn].handle = CreateFile("lofasz", GENERIC_WRITE, FILE_SHARE_READ, NULL, CREATE_ALWAYS, FILE_ATTRIBUTE_NORMAL, NULL);
	if (param->fds[param->fdn].handle == NULL) {
		fprintf(stderr, "CreateFile error: %d\n", GetLastError());
		return 1;
	}
	param->fds[param->fdn].mode = LOADER2_FD_MODE_WRITE|LOADER2_FD_MODE_TEXT;
	param->fdn++;

	ret = RunProcessWithFds("cat3", param, param_size, &pi);

/*
	ret = RunProcessWithFds("python cat3.py", param, param_size, &pi);
*/
/*
	ret = RunProcessWithFds("mawk -f cat3.awk", param, param_size, &pi);
*/

	if (ret != 0) {
		fprintf(stderr, "RunProcessWithFds error: %d\n", ret);
		return 1;
	}

	if (WaitForSingleObject(pi.hProcess, INFINITE) != WAIT_OBJECT_0) {
		fprintf(stderr, "WaitForSingleObject error: %d\n", GetLastError());
		return 1;
	}

	if (GetExitCodeThread(pi.hThread, (void *)&ret) == 0) {
		fprintf(stderr, "GetExitCodeThread error: %d\n", GetLastError());
		return 1;
	}

	if (ret != 0) {
		fprintf(stderr, "process error: %d\n", ret);
		return 1;
	}

	CloseHandle(pi.hThread);
	CloseHandle(pi.hProcess);

	for (i = 0; i < param->fdn; i++) {
		CloseHandle(param->fds[i].handle);
	}

	free(param);

	return 0;
}
