#include <stdlib.h>
#include <stdio.h>
#include <sys/types.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <unistd.h>
#include <string.h>
#include <libporty/net_resolver/net_resolver.h>

int main(int argc, char *argv[])
{
	char *fn, *end;
	int reverse;

	fn = argv[1];

	if (fn == NULL) {
		printf("ERROR: Need at least 1 argument\n");
		return -1;
	}

	P_net_resolver_log = stderr;

	end = fn + strlen(fn)-1;
	reverse = *end - '0';

	if (strncmp(fn, "req", 3) == 0) {
		char *req;
		int len;
		req = P_resolv_asm_req(argv[2], &len, reverse);
		if (req == NULL) {
			fprintf(stderr, "ERROR: invalid request\n");
			printf("FAIL\n");
			return 1;
		}
		write(1, req, len);
		return 0;
	}

	/* answer */
	{
		char req[512];
		int len;
		char hn[256];
		int fd;

		fd = open(fn, O_RDONLY);
		if (fd < 0) {
			printf("ERROR: can't open %s for reading\n", fn);
			return 1;
		}

		len = read(fd, req, sizeof(req));
		fprintf(stderr, "len=%d\n", len);
		if (len <= 0) {
			printf("ERROR: can't read %s\n", fn);
			return 1;
		}
		if (P_resolv_decode_ans(req, len, hn, reverse) == 0) {
			if (!reverse) {
				printf("OK '%d.%d.%d.%d'\n", (unsigned char)hn[0], (unsigned char)hn[1], (unsigned char)hn[2], (unsigned char)hn[3]);
			}
			else
				printf("OK '%s'\n", hn);
		}
		else
			printf("FAIL\n");
	}
	return 0;
}
